﻿Imports System.Text.RegularExpressions

Public Class frmTestAverDTW

    Private dtw As New averdtw8.AverDTW()        ' 
    Private arrPath As List(Of String) = New List(Of String)                ' list with all file pathes
    Private testPath As String = CurDir() & "\testdata\"

    ''' <summary>
    ''' Search for the files with extention = dat in the path = sDir
    ''' </summary>
    ''' <param name="sDir"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function SearchFile_RegEx(ByVal sDir As String) As List(Of String)

        Try
            ' string list
            Dim sFiles As List(Of String) = New List(Of String)
            Dim regExFile As Regex = New Regex(".dat$")

            ' control: directory exist
            Dim diTopDir As IO.DirectoryInfo = New IO.DirectoryInfo(sDir)
            If diTopDir.Exists Then
                ' search for the top directory
                Dim fiFiles() As IO.FileInfo = diTopDir.GetFiles("*", IO.SearchOption.TopDirectoryOnly)

                ' list of file names
                For i As Integer = 0 To fiFiles.Length - 1
                    If regExFile.IsMatch(fiFiles(i).FullName) Then
                        sFiles.Add(fiFiles(i).FullName)
                    End If
                Next
            End If
            ' gefundene Unterverzeichnise zurückgeben
            Return sFiles
        Catch ex As Exception
            MsgBox("Error in SearchFile_RegEx: " & ex.Message, MsgBoxStyle.OkOnly, MsgBoxStyle.Exclamation)
            Return Nothing
        End Try
    End Function

    Private Sub btnCalc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalc.Click

        Try
            Dim dblAverCurve(,) As Double       ' calculated average curve
            Dim dblMinCurve(,) As Double        ' calculated min values curve
            Dim dblMaxCurve(,) As Double        ' calculated max values curve
            Dim dblMedianCurve(,) As Double     ' calculated median curve
            Dim dbl25PercCurve(,) As Double     ' calculated 25 percentil curve
            Dim dbl75PercCurve(,) As Double     ' calculated 75 percentil curve

            Me.Cursor = Cursors.WaitCursor
            arrPath.Sort()

            ' IMPORTANT: start a new calculation
            Call dtw.StartNewCalc()

            dtw.DTWComp = CInt(DecimalLokal(txtCompNr.Text))
            ' count of intervals for result curves
            dtw.NumOfIntervals = CInt(txtNumOfIntervals.Text)
            ' window constraint for dtw matrix (percent)
            dtw.WinConstraint = CInt(txtWindowConstr.Text)

            ' smoothing factor for result curves
            dtw.SmoothAver = CDbl(DecimalLokal(txtAverSmooth.Text))
            dtw.SmoothMedian = CDbl(DecimalLokal(txtMedianSmooth.Text))
            dtw.Smooth25Perc = CDbl(DecimalLokal(txt25PercSmooth.Text))
            dtw.Smooth75Perc = CDbl(DecimalLokal(txt75PercSmooth.Text))
            dtw.SmoothMax = CDbl(DecimalLokal(txtMaxSmooth.Text))
            dtw.SmoothMin = CDbl(DecimalLokal(txtMinSmooth.Text))

            ' load all files
            For i As Integer = 0 To arrPath.Count - 1
                ' StreamReader zum Lesen aus einer Datei
                Dim sr As IO.StreamReader = New IO.StreamReader(arrPath(i))

                ' calculate the number of datasets in file
                Dim iCount As Integer = 0            ' count of files

                ' column headers
                Dim sRow As String = sr.ReadLine()
                ' help array
                Dim arrSplit() As String = Split(sRow, vbTab)
                ' count of rows
                Dim iComp As Integer = arrSplit.GetUpperBound(0)

                ' Units
                sRow = sr.ReadLine()
                Do While Not sr.EndOfStream
                    sRow = sr.ReadLine()
                    iCount = iCount + 1
                Loop
                sr.Close()

                ' dimension the array
                Dim dblNewCurve(0 To iComp, 0 To iCount - 1) As Double        ' array with data from one data file

                ' Load the data
                sr = New IO.StreamReader(arrPath(i))
                ' first 2 rows have no data
                sRow = sr.ReadLine()
                sRow = sr.ReadLine()

                ' read and save the data
                Dim j As Integer = -1      ' initializing
                Do While Not sr.EndOfStream
                    sRow = sr.ReadLine()
                    Dim arrDaten() As String = Split(sRow, vbTab)

                    j = j + 1
                    For k As Integer = 0 To UBound(arrDaten)
                        Select Case k
                            Case 0
                                ' time column
                                dblNewCurve(0, j) = CDbl(DecimalLokal(arrDaten(k)))
                            Case Is <= 8
                                ' components
                                dblNewCurve(k, j) = CDbl(DecimalLokal(arrDaten(k)))
                            Case Else
                        End Select
                    Next
                Loop
                sr.Close()

                Call dtw.AddOneCurve(dblNewCurve)
                If dtw.AverDtwError <> 0 Then
                    If MsgBox("Error in dtw.AddOneCurve(). Continue?",
                              vbQuestion, "QUESTION") = vbCancel Then
                        Me.Cursor = Cursors.Default
                        Exit Sub
                    End If
                End If
            Next

            'timer start
            tmrShow.Enabled = True
            'start the calculation of average curve
            ReDim dblAverCurve(0, 0)
            Call dtw.CalculateDTWAver(dblAverCurve)
            'timer stop
            tmrShow.Enabled = False

            If dtw.AverDtwError <> 0 Then
                ' error at the evaluating of the average curve
                txtState.Text = txtState.Text & vbCrLf & "Error"
                MsgBox("No calculated data!", vbExclamation, "ERROR")
                Me.Cursor = Cursors.Default
                Exit Sub
            End If

            If dtw.CalcReady Then
                ' save the aver curve
                Dim sw As IO.StreamWriter = New IO.StreamWriter(testPath & "aver\aver.dat")
                sw.WriteLine("Time" + vbTab + "Fx" + vbTab + "Fy" + vbTab + "Fz" + vbTab + "Fres" +
                            vbTab + "Mx" + vbTab + "My" + vbTab + "Mz" + vbTab + "Mres")
                sw.WriteLine("sec" + vbTab + "N" + vbTab + "N" + vbTab + "N" + vbTab + "N" + vbTab +
                            "Nm" + vbTab + "Nm" + vbTab + "Nm" + vbTab + "Nm")

                For i = 0 To UBound(dblAverCurve, 2)
                    Dim sRow As String = Format(Math.Round(dblAverCurve(0, i), 4), "#0.000#")
                    For j = 1 To UBound(dblAverCurve, 1)
                        sRow = sRow + vbTab + Format(Math.Round(dblAverCurve(j, i), 4), "00000.00")
                    Next j
                    sRow = Replace(sRow, ",", ".")
                    sw.WriteLine(sRow)
                    sRow = ""
                Next i
                sw.Close()

                dblMinCurve = dtw.MinDtw()

                ' save the min curve
                sw = New IO.StreamWriter(testPath & "aver\min_value.dat")
                sw.WriteLine("Time" + vbTab + "Fx" + vbTab + "Fy" + vbTab + "Fz" + vbTab + "Fres" +
                            vbTab + "Mx" + vbTab + "My" + vbTab + "Mz" + vbTab + "Mres")
                sw.WriteLine("sec" + vbTab + "N" + vbTab + "N" + vbTab + "N" + vbTab + "N" + vbTab +
                            "Nm" + vbTab + "Nm" + vbTab + "Nm" + vbTab + "Nm")

                For i = 0 To UBound(dblMinCurve, 2)
                    Dim sRow As String = Format(Math.Round(dblMinCurve(0, i), 4), "#0.000#")
                    For j = 1 To UBound(dblMinCurve, 1)
                        sRow = sRow + vbTab + Format(Math.Round(dblMinCurve(j, i), 4), "00000.00")
                    Next j
                    sRow = Replace(sRow, ",", ".")
                    sw.WriteLine(sRow)
                    sRow = ""
                Next i
                sw.Close()

                dblMaxCurve = dtw.MaxDtw()

                ' save the max curve
                sw = New IO.StreamWriter(testPath & "aver\max_value.dat")
                sw.WriteLine("Time" + vbTab + "Fx" + vbTab + "Fy" + vbTab + "Fz" + vbTab + "Fres" +
                            vbTab + "Mx" + vbTab + "My" + vbTab + "Mz" + vbTab + "Mres")
                sw.WriteLine("sec" + vbTab + "N" + vbTab + "N" + vbTab + "N" + vbTab + "N" + vbTab +
                            "Nm" + vbTab + "Nm" + vbTab + "Nm" + vbTab + "Nm")

                For i = 0 To UBound(dblMaxCurve, 2)
                    Dim sRow As String = Format(Math.Round(dblMaxCurve(0, i), 4), "#0.000#")
                    For j = 1 To UBound(dblMaxCurve, 1)
                        sRow = sRow + vbTab + Format(Math.Round(dblMaxCurve(j, i), 4), "00000.00")
                    Next j
                    sRow = Replace(sRow, ",", ".")
                    sw.WriteLine(sRow)
                    sRow = ""
                Next i
                sw.Close()

                dblMedianCurve = dtw.MedianDtw()

                ' save the median curve
                sw = New IO.StreamWriter(testPath & "aver\median.dat")
                sw.WriteLine("Time" + vbTab + "Fx" + vbTab + "Fy" + vbTab + "Fz" + vbTab + "Fres" +
                            vbTab + "Mx" + vbTab + "My" + vbTab + "Mz" + vbTab + "Mres")
                sw.WriteLine("sec" + vbTab + "N" + vbTab + "N" + vbTab + "N" + vbTab + "N" + vbTab +
                            "Nm" + vbTab + "Nm" + vbTab + "Nm" + vbTab + "Nm")

                For i = 0 To UBound(dblMedianCurve, 2)
                    Dim sRow As String = Format(Math.Round(dblMedianCurve(0, i), 4), "#0.000#")
                    For j = 1 To UBound(dblMedianCurve, 1)
                        sRow = sRow + vbTab + Format(Math.Round(dblMedianCurve(j, i), 4), "00000.00")
                    Next j
                    sRow = Replace(sRow, ",", ".")
                    sw.WriteLine(sRow)
                    sRow = ""
                Next i
                sw.Close()

                dbl25PercCurve = dtw.Perc25Dtw()

                ' save the 25 percentil curve
                sw = New IO.StreamWriter(testPath & "aver\perc25.dat")
                sw.WriteLine("Time" + vbTab + "Fx" + vbTab + "Fy" + vbTab + "Fz" + vbTab + "Fres" +
                            vbTab + "Mx" + vbTab + "My" + vbTab + "Mz" + vbTab + "Mres")
                sw.WriteLine("sec" + vbTab + "N" + vbTab + "N" + vbTab + "N" + vbTab + "N" + vbTab +
                            "Nm" + vbTab + "Nm" + vbTab + "Nm" + vbTab + "Nm")

                For i = 0 To UBound(dbl25PercCurve, 2)
                    Dim sRow As String = Format(Math.Round(dbl25PercCurve(0, i), 4), "#0.000#")
                    For j = 1 To UBound(dbl25PercCurve, 1)
                        sRow = sRow + vbTab + Format(Math.Round(dbl25PercCurve(j, i), 4), "00000.00")
                    Next j
                    sRow = Replace(sRow, ",", ".")
                    sw.WriteLine(sRow)
                    sRow = ""
                Next i
                sw.Close()

                dbl75PercCurve = dtw.Perc75Dtw()

                ' save the 75 peercentil curve
                sw = New IO.StreamWriter(testPath & "aver\perc75.dat")
                sw.WriteLine("Time" + vbTab + "Fx" + vbTab + "Fy" + vbTab + "Fz" + vbTab + "Fres" +
                            vbTab + "Mx" + vbTab + "My" + vbTab + "Mz" + vbTab + "Mres")
                sw.WriteLine("sec" + vbTab + "N" + vbTab + "N" + vbTab + "N" + vbTab + "N" + vbTab +
                            "Nm" + vbTab + "Nm" + vbTab + "Nm" + vbTab + "Nm")

                For i = 0 To UBound(dbl75PercCurve, 2)
                    Dim sRow As String = Format(Math.Round(dbl75PercCurve(0, i), 4), "#0.000#")
                    For j = 1 To UBound(dbl75PercCurve, 1)
                        sRow = sRow + vbTab + Format(Math.Round(dbl75PercCurve(j, i), 4), "00000.00")
                    Next j
                    sRow = Replace(sRow, ",", ".")
                    sw.WriteLine(sRow)
                    sRow = ""
                Next i
                sw.Close()

                txtState.Text = txtState.Text & vbCrLf & "Ready"

                MsgBox("Calculated data:" + vbCrLf +
                       "  aver.dat      - average curve" + vbCrLf +
                       "  max_value.dat - curve with max values" + vbCrLf +
                       "  min_value.dat - curve with min values" + vbCrLf +
                       "  median.dat    - median curve" + vbCrLf +
                       "  perc25.dat    - 25 percentil curve" + vbCrLf +
                       "  perc75.dat    - 75 percentil curve" + vbCrLf +
                       "were saved in " + testPath & "aver", vbInformation, "INFO")
            Else
                MsgBox("No calculated data!", vbExclamation, "ERROR")
            End If

            Me.Cursor = Cursors.Default
        Catch ex As Exception
            MsgBox("Error: " & ex.Message, MsgBoxStyle.OkOnly, MsgBoxStyle.Exclamation)
        End Try

    End Sub

    ''' <summary>
    ''' Replace the decimal point if required
    ''' </summary>
    ''' <param name="strQuelle"></param>
    ''' <returns></returns>
    Public Function DecimalLokal(ByVal strQuelle As String) As String

        Dim decZeich As String
        Dim strHelp As String

        ' Identify the decimal point
        strHelp = Format(0.1, "0.0")
        decZeich = Strings.Mid(strHelp, 2, 1)

        ' Replace the decimal point if required
        If decZeich = "," And InStr(1, strQuelle, ".") > 0 Then
            DecimalLokal = Replace(strQuelle, ".", ",")
        ElseIf decZeich = "." And InStr(1, strQuelle, ",") > 0 Then
            DecimalLokal = Replace(strQuelle, ",", ".")
        Else
            DecimalLokal = strQuelle
        End If

    End Function

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Private Sub frmTestAverDTW_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' Example: set the values from averdtw.dll
        ' component number for the calculating of dtw path
        dtw.DTWComp = CInt(DecimalLokal(txtCompNr.Text))
        ' count of intervals for result curves
        dtw.NumOfIntervals = CInt(txtNumOfIntervals.Text)
        ' window constraint for dtw matrix (percent)
        dtw.WinConstraint = CInt(txtWindowConstr.Text)

        ' smoothing factor for result curves
        dtw.SmoothAver = CDbl(DecimalLokal(txtAverSmooth.Text))
        dtw.SmoothMedian = CDbl(DecimalLokal(txtMedianSmooth.Text))
        dtw.Smooth25Perc = CDbl(DecimalLokal(txt25PercSmooth.Text))
        dtw.Smooth75Perc = CDbl(DecimalLokal(txt75PercSmooth.Text))
        dtw.SmoothMax = CDbl(DecimalLokal(txtMaxSmooth.Text))
        dtw.SmoothMin = CDbl(DecimalLokal(txtMinSmooth.Text))

        ' search all files for the calculation
        testPath = CurDir() & "\testdata\"
        arrPath = New List(Of String)
        arrPath = SearchFile_RegEx(testPath)

        ' show files in the ListView
        If arrPath(0) <> "" Then
            For i As Integer = 0 To arrPath.Count - 1
                lstFiles.Items.Add(arrPath(i))
            Next i
        End If
    End Sub

    ''' <summary>
    ''' Show the calculation commets
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub tmrShow_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrShow.Tick
        ' load the comments
        txtState.Text = dtw.Comment()
    End Sub

    ''' <summary>
    ''' Load data for test1
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub btnLoadTest1_Click(sender As Object, e As EventArgs) Handles btnLoadTest1.Click
        lstFiles.Items.Clear()
        txtCompNr.Text = "1"
        ' search all files for the calculation
        arrPath = New List(Of String)
        testPath = CurDir() & "\testdata1\"
        arrPath = SearchFile_RegEx(testPath)

        ' show files in the ListView
        If arrPath(0) <> "" Then
            For i = 0 To arrPath.Count - 1
                lstFiles.Items.Add(arrPath(i))
            Next i
        End If
    End Sub

    ''' <summary>
    ''' Load data for test2
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub btnLoadTest2_Click(sender As Object, e As EventArgs) Handles btnLoadTest2.Click
        lstFiles.Items.Clear()
        txtCompNr.Text = "4"
        ' search all files for the calculation
        arrPath = New List(Of String)
        testPath = CurDir() & "\testdata2\"
        arrPath = SearchFile_RegEx(testPath)

        ' show files in the ListView
        If arrPath(0) <> "" Then
            For i = 0 To arrPath.Count - 1
                lstFiles.Items.Add(arrPath(i))
            Next i
        End If
    End Sub

End Class
